/*--------------------------------------------------------------------------
  Project:  Manual 2D Library - m2d
  File:     Texture.h

  Copyright (C)2007-2009 Nintendo  All Rights Reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Revision: 1758 $
 *-------------------------------------------------------------------------*/

#ifndef NTMV_M2D_TEXTURE_H_
#define NTMV_M2D_TEXTURE_H_

#if defined(__CWCC__)
#pragma once
#endif

#include <nitro/types.h>
#include <nitro/gx/g3.h>
#include <ntmv/m2d/resources.h>

namespace ntmv
{
namespace m2d
{

/*
    Texture class
*/
class Texture
{
public:
                        Texture()
                        :   mpImageHd(0)
                        {}

    void                Set(const ImageHeader* pImageHd)    { mpImageHd = pImageHd; }

    const Size          GetSize() const
    {
        return Size(
            static_cast<s16>(mpImageHd->width ),
            static_cast<s16>(mpImageHd->height) );
    }

    GXTexFmt            GetTexelFormat() const      { return GXTexFmt(mpImageHd->texelFormat); }

    u16                 GetPaletteEntryNum() const  { return mpImageHd->paletteEntryNum; }

    const ImageHeader*  GetImageHeader() const      { return mpImageHd; }


private:
    const ImageHeader*  mpImageHd;
};

}   // namespace m2d
}   // namespace ntmv

/* NTMV_M2D_TEXTURE_H_ */
#endif
